﻿Public Class Form1
    Private WithEvents AllL As New CLines

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Загружаем файлик тестовый ;) 965 строк
        AllL.Lines = IO.File.ReadAllLines("test.txt", System.Text.Encoding.GetEncoding("windows-1251"))
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize, AllL.TextChange
        'Получаем рабочую область
        Dim r As Rectangle = Page.ClientRectangle : r.Width -= vScroll.Width
        'Пересчитываем строки для новой рабочей области :( такой способ медленный, 
        'как(оптимизировать) ума не приложу
        AllL.RecalcVirtualLines(Page.CreateGraphics, Page.Font, r)
        'Ниже регулируем скролинг, там все лажа можно не зацикливаться, сделано на спех
        Dim all As Integer = AllL.CountOfVirtualLines
        vScroll.Maximum = (all + 9) - Page.Height \ Page.Font.Height
        Try
            If vScroll.Value > all - (Page.Height \ Page.Font.Height) Then vScroll.Value = all - Page.Height \ Page.Font.Height
        Catch ex As Exception
        End Try
        Me.Refresh()
    End Sub

    'Отображает текст виртуальной строки под курсором
    Private Sub Page_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Page.MouseMove
        Dim SelLine As Integer = vScroll.Value + (e.Y \ Page.Font.Height)
        If SelLine > AllL.CountOfVirtualLines - 1 Then Exit Sub
        Dim SelText As String = (SelLine + 1).ToString & ": " & AllL.GetVirtulLine(SelLine)
        TextBox1.Text = SelText
    End Sub

    'Не обращать вниманиЯ
    Private Sub Page_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Page.MouseUp
        TextBox1.Focus()
    End Sub

    'Отрисовываем строки
    Private Sub Page_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Page.Paint
        Dim i As Integer = 0
        Dim y As Integer = 0
        'Кол-во строк которые влезут в видимую часть
        Dim EndLine As Integer = vScroll.Value + (Page.Height \ Page.Font.Height)
        If EndLine >= AllL.CountOfVirtualLines Then EndLine = AllL.CountOfVirtualLines - 1
        For i = vScroll.Value To EndLine
            e.Graphics.DrawString(AllL.GetVirtulLine(i), Page.Font, Brushes.Black, 0, y)
            y += Page.Font.Height
        Next
        Me.Text = "Кол-во виртуальных линий: " & AllL.CountOfVirtualLines & " № первой видимой линии: " & vScroll.Value + 1
    End Sub

    'Перенос по строкам
    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        AllL.WordWrap = CheckBox1.Checked
    End Sub

    'Навигация скролингом
    Private Sub vScroll_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles vScroll.ValueChanged
        Try
            Dim all As Integer = AllL.CountOfVirtualLines
            If vScroll.Value < 0 Then vScroll.Value = 0
            If vScroll.Value > all - Page.Height \ Page.Font.Height Then vScroll.Value = all - Page.Height \ Page.Font.Height
        Catch ex As Exception
        End Try
        Me.Refresh()
        TextBox1.Focus()
    End Sub

    Private Sub TextBox1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.GotFocus
        TextBox1.SelectionLength = 0
    End Sub

    'На текстовик повешал скролинг, так чтоб просмотреть скорость обновления строк
    'а на текстовик, так-как на панельи не срабатывает такое событие
    Private Sub TextBox1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox1.MouseWheel
        Try
            If e.Delta > 0 Then
                vScroll.Value -= 10
            Else
                vScroll.Value += 10
            End If
        Catch ex As Exception
            If e.Delta > 0 Then
                vScroll.Value = 0
            Else
                vScroll.Value = vScroll.Maximum
            End If
        End Try
    End Sub

    Private Sub CheckBox1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox1.GotFocus
        TextBox1.Focus()
    End Sub
End Class

'Класс для обработки коллекции строк (текста)
Public Class CLines
    'Событие
    Public Event TextChange(ByVal sender As Object, ByVal e As EventArgs)
    'Тут будем хранить линии
    Private _Lines As New Dictionary(Of Integer, CLine)
    'Свойство перенос по словам
    Private _WordWrap As Boolean = False
    'Тут будем хранить координаты виртуальных линий
    Private _NavigationOnVirtualLines(-1) As SNavigationOnVirtualLines

    'Обработчик свойства Перенос по словам
    Public Property WordWrap() As Boolean
        Get
            Return _WordWrap
        End Get
        Set(ByVal value As Boolean)
            _WordWrap = value
            Dim i As Integer = 0
            For i = 0 To _Lines.Count - 1
                _Lines(i).WordWrap = value
            Next
            RaiseEvent TextChange(Me, New EventArgs)
        End Set
    End Property

    'Пересчет виртуальных строк
    'Эх, не нравится мне эта процедура, на большом тексте будет медленно работать (((
    'Как оптимизировать незнаю возможно нужно вообще пересмотреть всю систему
    'ну это пока первый шаг на пути к Текстовому полю.
    Public Sub RecalcVirtualLines(ByVal g As Graphics, ByVal f As Font, ByVal r As Rectangle)
        Dim i As Integer = 0
        ReDim _NavigationOnVirtualLines(-1)
        For i = 0 To _Lines.Count - 1
            _Lines(i).RecalcVirtualLines(g, f, r, _NavigationOnVirtualLines)
        Next
    End Sub

    'Кол-во линий реальных
    Public ReadOnly Property CountOfLines() As Integer
        Get
            Return _Lines.Count
        End Get
    End Property

    'Кол-во линий виртуальных
    Public Function GetVirtulLine(ByVal index As Integer) As String
        Dim i As Integer = 0
        Dim k As Integer = 0
        Return _Lines(_NavigationOnVirtualLines(index).IndexOfMainLine).GetVirtulLine(_NavigationOnVirtualLines(index).IndexOfVirtualLine)
    End Function

    'Кол-во виртуальных линий
    Public ReadOnly Property CountOfVirtualLines() As Integer
        Get
            Return _NavigationOnVirtualLines.Length
        End Get
    End Property

    'Загружаем строки из массива строк, или ворачиваем массив
    Public Property Lines() As String()
        Get
            Dim l(_Lines.Count - 1) As String
            Dim i As Integer = 0
            For i = 0 To _Lines.Count - 1
                l(i) = _Lines(i).Text
            Next
            Return l
        End Get
        Set(ByVal value() As String)
            Dim i As Integer
            _Lines = New Dictionary(Of Integer, CLine)
            For i = 0 To value.Length - 1
                Dim l As New CLine
                l.Text = value(i)
                l.WordWrap = WordWrap
                _Lines.Add(i, l)
            Next
            RaiseEvent TextChange(Me, New EventArgs)
        End Set
    End Property

    'Структура хранящая информацию о координатах виртуальной строки
    Public Structure SNavigationOnVirtualLines
        Public IndexOfMainLine As Integer
        Public IndexOfVirtualLine As Integer
    End Structure
End Class

Public Class CLine
    Implements ILine
    'Событие срабатываемое при Изменении текста или WordWrap
    Public Event TextChange(ByVal sender As Object, ByVal e As System.EventArgs) Implements ILine.TextChange
    'Тут будем хранить детали виртуальных линий
    Private _VirtualLines(-1) As SVirtualLineDetals
    'Тут хранится текст строки
    Private _Text As String = ""
    '
    Private _WordWrap As Boolean = False
    '
    'Ворачивает кол-во виртуальных линий
    Public ReadOnly Property CountOfVirtualLines() As Integer Implements ILine.CountOfVirtualLines
        Get
            Return _VirtualLines.Length
        End Get
    End Property

    'Возвращает виртуальную линию
    Public Function GetVirtulLine(ByVal Index As Integer) As String Implements ILine.GetVirtulLine
        If Index >= 0 And Index <= CountOfVirtualLines - 1 Then
            Return Text.Substring(_VirtualLines(Index).Start, _VirtualLines(Index).Lenght)
        Else
            Return Nothing
        End If
    End Function

    'Пересчет виртуальных линий
    Public Sub RecalcVirtualLines(ByVal g As Graphics, ByVal f As Font, ByVal r As Rectangle, ByRef NavigationOnVirtualLines() As CLines.SNavigationOnVirtualLines) Implements ILine.RecalcVirtualLines
        'Обнуляем информацию о строках
        ReDim _VirtualLines(-1)
        'Индекс строки, реальной
        Dim IndexOfMainLine As Integer = 0
        'Если эот не первая виртуальная линия
        If NavigationOnVirtualLines.Length > 0 Then
            'Получаем индекс текущей строки путем инкременирования номера строки из предедущего элемента массива
            IndexOfMainLine = NavigationOnVirtualLines(NavigationOnVirtualLines.Length - 1).IndexOfMainLine + 1
        End If
        'Если режим переноса строк не включен выходим
        If Not WordWrap Then
            'Увеличиваем счетчик линий до 1 элемента
            ReDim Preserve _VirtualLines(0)
            'Так как строка 1, то устанавливаем координаты для виртуальной с 0
            _VirtualLines(0).Start = 0
            'длинна равна длинне реальной строки
            _VirtualLines(0).Lenght = Text.Length
            'Увеличиваем счетчик виртуальных линий для основного класса
            ReDim Preserve NavigationOnVirtualLines(NavigationOnVirtualLines.Length)
            'Устанавливаем индекс родительской строки
            NavigationOnVirtualLines(NavigationOnVirtualLines.Length - 1).IndexOfMainLine = IndexOfMainLine
            'Устанавливаем индекс виртуальной строки
            NavigationOnVirtualLines(NavigationOnVirtualLines.Length - 1).IndexOfVirtualLine = 0
            Exit Sub
        End If
        'Настраиваем формат строки
        'Указываем что переносить строку не нужно
        Dim sf As New StringFormat(StringFormatFlags.NoWrap)
        'Обрезать до ближайшего слова
        sf.Trimming = StringTrimming.Word
        'Индекс символа в строке
        Dim i As Integer = 0
        'Номер виртуальной линии
        Dim n As Integer = 0
        'Повторять
        Do
            'Кол-во символов которые влезли
            Dim CharsOnLine As Integer
            'Примерям строку к рабочей области ;)
            g.MeasureString(_Text.Substring(i), f, r.Size, sf, CharsOnLine, New Integer)
            'Увеличиваем кол-во виртуальных линий
            ReDim Preserve _VirtualLines(CountOfVirtualLines)
            'Заполняем структуру деталями
            'Начало подстроки
            _VirtualLines(CountOfVirtualLines - 1).Start = i
            'Длинна подстроки
            _VirtualLines(CountOfVirtualLines - 1).Lenght = CharsOnLine
            'Увеличиваем счетчик виртуальных линий для основного класса
            ReDim Preserve NavigationOnVirtualLines(NavigationOnVirtualLines.Length)
            'Устанавливаем индекс родительской строки
            NavigationOnVirtualLines(NavigationOnVirtualLines.Length - 1).IndexOfMainLine = IndexOfMainLine
            'Устанавливаем индекс виртуальной строки
            NavigationOnVirtualLines(NavigationOnVirtualLines.Length - 1).IndexOfVirtualLine = n
            'Перемещаемся дальше
            i += CharsOnLine
            'Увеличиваем номер виртуальной линии
            n += 1
            'Пока не достигли конца строки
        Loop While i < _Text.Length
    End Sub

    'Устанавливаем/получаем Текст строки
    Public Property Text() As String Implements ILine.Text
        Get
            Return _Text
        End Get
        Set(ByVal value As String)
            _Text = value
            RaiseEvent TextChange(Me, New EventArgs)
        End Set
    End Property

    'Устанавливаем/получаем режим переноса строк
    Public Property WordWrap() As Boolean Implements ILine.WordWrap
        Get
            Return _WordWrap
        End Get
        Set(ByVal value As Boolean)
            _WordWrap = value
            RaiseEvent TextChange(Me, New EventArgs)
        End Set
    End Property

    'Вспомогательная структура
    Private Structure SVirtualLineDetals
        Public Start As Integer
        Public Lenght As Integer
    End Structure
End Class

'На интерфейс не смотри, это так для себя общий вид
Public Interface ILine
    'События
    Event TextChange(ByVal sender As Object, ByVal e As EventArgs)
    'Свойства ReadWrite
    Property Text() As String
    Property WordWrap() As Boolean
    'Свойства ReadOnly
    ReadOnly Property CountOfVirtualLines() As Integer
    'Функции
    Function GetVirtulLine(ByVal Index As Integer) As String
    'Процедуры
    Sub RecalcVirtualLines(ByVal g As Graphics, ByVal f As Font, ByVal r As Rectangle, ByRef NavigationOnVirtualLines() As CLines.SNavigationOnVirtualLines)
End Interface
